package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.DrugDeliveryNoteApplyInfo;
import com.alihealth.d2d.provtest.entity.EventBasic;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.service.IDrugDeliveryNoteApplyInfoService;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;

@Service
@EventSubType("2016")
public class SubType2016Handler extends AbstractEventDataHandler<DrugDeliveryNoteApplyInfo> {

    @Autowired
    private IDrugDeliveryNoteApplyInfoService service;

    @Override
    protected Class<DrugDeliveryNoteApplyInfo> getEntityClass() {
        return DrugDeliveryNoteApplyInfo.class;
    }

    @Override
    protected IService<DrugDeliveryNoteApplyInfo> getService() {
        return service;
    }

    @Override
    protected DrugDeliveryNoteApplyInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance) {
        EventBasic evtBasic = eventBody.getEvtBasic();
        //时间格式
        SimpleDateFormat formatterDatetime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //日期格式
        SimpleDateFormat formatterDate = new SimpleDateFormat("yyyyMMdd");

        try {
            return DrugDeliveryNoteApplyInfo.builder()
                    .eventId(eventBody.getEventID())
                    .recTime(formatterDatetime.parse(eventBody.getRecTime()))

                    .ypzsm(instance.getString("YPZSM"))
                    .bzcj(instance.getString("BZCJ"))
                    .syjbzypzsm(instance.getString("SYJBZYPZSM"))
                    .zsmyzzt(instance.getString("ZSMYZZT"))
                    .ymzt(instance.getString(("YMZT")))

                    .tyshxydmscqy(item.getString("TYSHXYDMSCQY"))
                    .scqymc(item.getString("SCQYMC"))
                    .yptymc(item.getString("YPTYMC"))
                    .gjypbsm(item.getString("GJYPBSM"))
                    .ymscph(item.getString("YMSCPH"))
                    .scrq(formatterDate.parse(item.getString("SCRQ")))
                    .tyshxydmjkymdlqy(item.getString("TYSHXYDMJKYMDLQY"))
                    .jkymdlqymc(item.getString("JKYMDLQYMC"))
                    .ymyxqjzrq(formatterDate.parse(item.getString("YMYXQJZRQ")))
                    .yshsl(item.getInt("YSHSL"))
                    .shsl(item.getInt("SHSL"))
                    .ymssxkcyrmc(item.getString("YMSSXKCYRMC"))
                    .tyshxydmymssxkcyr(item.getString("TYSHXYDMMYMSSXKCYR"))
                    .jx(item.getString("JX"))
                    .bzgg(item.getString("BZGG"))
                    .zjgg(item.getString("ZJGG"))
                    .bzzhb(Integer.parseInt(item.getString("BZZHB")))
                    .bzzhbdw(item.getString("BZZHBDW"))
                    .ypzcfl(item.getString("YPZCFL"))
                    .tsypglfl(item.getString("TSYPGLFL"))

                    .dhdbh(evtBasic.getString("DHDBH"))
                    .fhdbh(evtBasic.getString("FHDBH"))
                    .shdbh(evtBasic.getString("SHDBH"))
                    .tyshxydmfhjg(evtBasic.getString("TYSHXYDMFHJG"))
                    .jzdwbmfhjg(evtBasic.getString("JZDWBMMFHJG"))
                    .fhjgmc(evtBasic.getString("FHJGMC"))
                    .fhdz(evtBasic.getString("FHDZ"))
                    .tyshxydmshjg(evtBasic.getString("TYSHXYDMSHJG"))
                    .jzdwbmshjg(evtBasic.getString("JZDWBMSHJG"))
                    .shdz(evtBasic.getString("SHDZ"))
                    .shjgmc(evtBasic.getString("SHJGMC"))
                    .shlx(evtBasic.getString("SHLX"))
                    .shsj(formatterDatetime.parse(evtBasic.getString("SHSJ")))
                    .djyzzt(evtBasic.getString("DJYZZT"))
                    .djyzrq(formatterDate.parse(evtBasic.getString("DJYZRQ")))
                    .djyzwtgyy(evtBasic.getString("DJYZWTGYY"))

                    .shrmc(evtBasic.getString("SHR"))

                    .fhjglx(evtBasic.getString("FHJGLX"))
                    .shjglx(evtBasic.getString("SHJGLX"))
                    .fhjgxl(evtBasic.getString("FHJGXL"))
                    .shjgxl(evtBasic.getString("SHJGXL"))
                    .wsjgdmshjg(evtBasic.getString("WSJGDMSHJG"))
                    .wsjgdmfhjg(evtBasic.getString("WSJGDMFHJG"))
                    .zyxkzdjhfhjg(evtBasic.getString("ZYXKZDJHFHJG"))
                    .zyxkzdjhshjg(evtBasic.getString("ZYXKZDJHSHJG"))
                    .wtdwmc(evtBasic.getString("WTDWMC"))
                    .wtdwtyshxydm(evtBasic.getString("WTDWTYSHXYDM"))
                    .build();
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public String getSubType() {
        return "2016";
    }

    @Override
    public void handleBase(String xml, String eventId) {

    }
}
